/*
 * Tapiocaui app
 * Copyright (C) 2005 INdT
 * @author Renato Araujo Oliveira Filho <renato.filho@indt.org.br>
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
 */

#ifndef __TAPIOCAUI_BUDDY_LIST_H__
#define __TAPIOCAUI_BUDDY_LIST_H__

#include "tapiocaui_db.h"
#include "tapiocaui_list.h"

G_BEGIN_DECLS

#define TAPIOCAUI_TYPE_BUDDY_LIST         (tapiocaui_buddy_list_get_type ())
#define TAPIOCAUI_BUDDY_LIST(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TAPIOCAUI_TYPE_BUDDY_LIST, TapiocaUIBuddyList))
#define TAPIOCAUI_BUDDY_LIST_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TAPIOCAUI_TYPE_BUDDY_LIST, TapiocaUIBuddyListClass))
#define TAPIOCAUI_IS_BUDDY_LIST(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TAPIOCAUI_TYPE_BUDDY_LIST))
#define TAPIOCAUI_IS_BUDDY_LIST_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TAPIOCAUI_TYPE_BUDDY_LIST))
#define TAPIOCAUI_BUDDY_LIST_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TAPIOCAUI_TYPE_BUDDY_LIST, TapiocaUIBuddyListClass))

typedef struct _TapiocaUIBuddyList        TapiocaUIBuddyList;
typedef struct _TapiocaUIBuddyListClass   TapiocaUIBuddyListClass;
typedef struct _TapiocaUIBuddyListPrivate TapiocaUIBuddyListPrivate;

struct _TapiocaUIBuddyListClass
{
    TapiocaUIListClass parent_class;

    void (* buddy_activated)         (TapiocaUIBuddyList *self, 
                                      TapiocaUIBuddyData *buddy,
                                      gboolean            do_call);
    void (* buddy_selection_changed) (TapiocaUIBuddyList *self, 
                                      TapiocaUIBuddyData *buddy,
                                      gboolean            is_selected);
};

struct _TapiocaUIBuddyList
{
    TapiocaUIList parent;
  
    TapiocaUIBuddyListPrivate *priv;
};

GType               tapiocaui_buddy_list_get_type        (void);
TapiocaUIBuddyList *tapiocaui_buddy_list_new             (void);
void                tapiocaui_buddy_list_connect_db      (TapiocaUIBuddyList *self,
                                                          TapiocaUIDB        *db);
void                tapiocaui_buddy_list_disconnect_db   (TapiocaUIBuddyList *self);
void                tapiocaui_buddy_list_clear           (TapiocaUIBuddyList *self);
GList              *tapiocaui_buddy_get_selected_buddies (TapiocaUIBuddyList *self);
TapiocaUIBuddyData *tapiocaui_buddy_list_get_buddy       (TapiocaUIBuddyList *self,
                                                          GtkTreeIter        *iter);
void                tapiocaui_buddy_list_append_buddy    (TapiocaUIBuddyList *self,
                                                          TapiocaUIBuddyData *card);
void                tapiocaui_buddy_list_append_list     (TapiocaUIBuddyList *self,
                                                          GList              *list);
void                tapiocaui_buddy_list_remove_buddy    (TapiocaUIBuddyList *self,
                                                          TapiocaUIBuddyData *buddy);
void                tapiocaui_buddy_list_set_filter      (TapiocaUIBuddyList *self,
                                                          const gchar        *value);
void                tapiocaui_buddy_list_update          (TapiocaUIBuddyList *self);

G_END_DECLS

#endif
