/*
 * Tapiocaui app
 * Copyright (C) 2005 INdT
 * @author Renato Araujo Oliveira Filho <renato.filho@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
 */

#ifndef __TAPIOCAUI_SHELL_H__
#define __TAPIOCAUI_SHELL_H__

#include <glib.h>
#include <glib/gtypes.h>
#include <glib/glist.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define TAPIOCAUI_TYPE_SHELL         (tapiocaui_shell_get_type ())
#define TAPIOCAUI_SHELL(o)           (G_TYPE_CHECK_INSTANCE_CAST ((o), TAPIOCAUI_TYPE_SHELL, TapiocaUIShell))
#define TAPIOCAUI_SHELL_CLASS(k)     (G_TYPE_CHECK_CLASS_CAST((k), TAPIOCAUI_TYPE_SHELL, TapiocaUIShellClass))
#define TAPIOCAUI_IS_SHELL(o)        (G_TYPE_CHECK_INSTANCE_TYPE ((o), TAPIOCAUI_TYPE_SHELL))
#define TAPIOCAUI_IS_SHELL_CLASS(k)  (G_TYPE_CHECK_CLASS_TYPE ((k), TAPIOCAUI_TYPE_SHELL))
#define TAPIOCAUI_SHELL_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), TAPIOCAUI_TYPE_SHELL, TapiocaUIShellClass))

typedef struct _TapiocaUIShell        TapiocaUIShell;
typedef struct _TapiocaUIShellClass   TapiocaUIShellClass;
typedef struct _TapiocaUIShellPrivate TapiocaUIShellPrivate;

struct _TapiocaUIShellClass
{
    GObjectClass parent_class;
};

struct _TapiocaUIShell
{
    GObject parent;
    
    TapiocaUIShellPrivate *priv;
};

GType           tapiocaui_shell_get_type         (void);
TapiocaUIShell *tapiocaui_shell_new              (void);
gboolean        tapiocaui_shell_initialize       (TapiocaUIShell *self);
void            tapiocaui_shell_terminate        (TapiocaUIShell *self);

#endif
