/*
 * Tapiocaui app
 * Copyright (C) 2005 INdT
 * @author Renato Araujo Oliveira Filho <renato.filho@indt.org.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA02111-1307USA
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <gtk/gtkiconfactory.h>
#include <gtk/gtkstock.h>
#include <gdk/gdkpixbuf.h>

#include "tapiocaui_stock_icons.h"

typedef struct {
    char *stock_id;
    char *icon;
} TapiocaUIStockIcon;

static const TapiocaUIStockIcon stock_icons [] = {
    { TAPIOCAUI_STOCK_VOLUME_MUTE, "stock_volume-mute" },
    { TAPIOCAUI_STOCK_VOLUME_0,    "stock_volume-0" },
    { TAPIOCAUI_STOCK_VOLUME_MIN,  "stock_volume-min" },
    { TAPIOCAUI_STOCK_VOLUME_MED,  "stock_volume-med" },
    { TAPIOCAUI_STOCK_VOLUME_MAX,  "stock_volume-max" },
    { TAPIOCAUI_STOCK_MEDIA_PAUSE, "stock_media-pause" },
    { TAPIOCAUI_STOCK_MEDIA_PLAY,  "stock_media-play" },
    { TAPIOCAUI_STOCK_MIC,         "stock_mic" }
};

void
tapiocaui_stock_icons_init (void)
{
    GtkIconFactory *factory;
    GtkIconSource *source;
    gint i;

    factory = gtk_icon_factory_new ();
    gtk_icon_factory_add_default (factory);

    source = gtk_icon_source_new ();

    for (i = 0; i < G_N_ELEMENTS (stock_icons); i++) {
        GtkIconSet *set;

        gtk_icon_source_set_icon_name (source, stock_icons [i].icon);

        set = gtk_icon_set_new ();
        gtk_icon_set_add_source (set, source);

        gtk_icon_factory_add (factory, stock_icons [i].stock_id, set);
        gtk_icon_set_unref (set);
    }

    gtk_icon_source_free (source);

    g_object_unref (G_OBJECT (factory));
}
